--[[--
	- Laser Pointer -
	Author: Dark Byte/failbit
--]]--

ALLOW_TO_CHECK_PLAYER_POINTER_COLLISION = true;

addhook("always", "EpicLag");
addhook("serveraction", "action")

COLOR__ = {[0]=255,0,0};
function Plot(x,y)
	x = x; y = y;
	local img = image("gfx/plot.bmp",x,y,1,0);
	imagecolor(img,COLOR__[0],COLOR__[1],COLOR__[2]);
	return img;
end

local img_data = {};
local last_rot = {};
local lsr_pntr_on = {}
local end_pnt = {}
for i = 31, 0, -1 do
	img_data[i] = -1;
	last_rot[i] = 0.1024;
	lsr_pntr_on[i] = false
	end_pnt[i] = -1
end

function action(id, a)
	if ( a == 3 ) then
		lsr_pntr_on[id] = not lsr_pntr_on[id]
	end
end

function ConvertCoord(x)
	return math.floor(x/32);
end

function findchange(x,y)
	return math.abs(x-y)/x;
end
tile_ = tile;
function tile(x,y,what,ignore)
	if ( what ~= "playeron" ) then
		return tile_(x,y,what);
	end
	if ( ALLOW_TO_CHECK_PLAYER_POINTER_COLLISION ) then
		for i = 1, 32 do
			if ( player(i, "exists") ) then
				local px = player(i, "x")-12
				local py = player(i, "y")-12
				if ( x >= px and y >= py and x <= px + 24 and y <= py+24 and i ~= ignore and player(i, "health") > 0 ) then
					return true;
				end
			end
		end
		return false;
	end
end

function drawLaserPointer(p)
	--if ( last_rot[p-1] ~= player(p,"rot") ) then
		local rot,x,y = (player(p,"rot")-90)*math.pi/180,player(p,"x"),player(p,"y");
		last_rot[p-1] = player(p, "rot");
		x = x + 16*math.cos(rot);
		y = y + 16*math.sin(rot);

		local scale = 32;

		if ( img_data[p-1] == -1 ) then
			img_data[p-1] = image("gfx/plot_.bmp",x,y,1,0);
		end

		while ( (not tile(ConvertCoord(x),ConvertCoord(y),"wall")) and (not tile(x, y, "playeron", p)) ) do
			x = x+math.cos(rot);
			y = y+math.sin(rot);
			scale = scale + 1;
			--imagepos(img_data[p-1], player(p,"x"), player(p,"y"), rot*180/math.pi);
		end
		if ( end_pnt[p-1] == -1 ) then
			end_pnt[p-1] = image("gfx/flare_fb.bmp", x, y, 1, 0)
		end
		imagepos(end_pnt[p-1], x, y, math.random(0, 360))
		imagescale(end_pnt[p-1], 0.1, 0.1)
		imagecolor(end_pnt[p-1], COLOR__[0], COLOR__[1], COLOR__[2])

		imagescale(img_data[p-1], findchange(32, scale),1);
		imagepos(img_data[p-1], player(p,"x")+(scale/2)*math.cos(rot), player(p,"y")+(scale/2)*math.sin(rot), rot*180/math.pi);
		imagecolor(img_data[p-1], COLOR__[0], COLOR__[1], COLOR__[2]);
		imagealpha(img_data[p-1], 0.65);
	--end
end

addhook("die", "die__")
function die__(id)
	lsr_pntr_on[id] = false
end

function EpicLag()
	for i = 1,32 do
		if ( player(i,"exists") and player(i,"health") > 0 and lsr_pntr_on[i] ) then
			drawLaserPointer(i);
		else
			if ( img_data[i-1] ~= -1 ) then
				imagealpha(img_data[i-1], 0)
			end
			if ( end_pnt[i-1] ~= -1 ) then
				freeimage(end_pnt[i-1])
				end_pnt[i-1] = -1
			end
		end
	end
end
